//+------------------------------------------------------------------------------------------+
//|                                                                                 RSI+.mq4 |
//+------------------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------------- 1 --
#property indicator_separate_window                                     //    
#property indicator_buffers 4                                           //  
#property indicator_color1 Blue                                         //  RSI+
#property indicator_color2 Black                                        //  MA  RSI+
#property indicator_style2 STYLE_DOT                                    //   RSI+    
#property indicator_color3 Red                                          //    RSI+
#property indicator_style3 STYLE_DASH                                   //  RSI+    
#property indicator_color4 LimeGreen                                    //    RSI+
#property indicator_style4 STYLE_DASH                                   //  RSI+    
//+-------------------------------------------------------------------------------------- 2 --
#property indicator_level1 80                                           //1-  4-  
#property indicator_levelcolor Silver                                   //  1-  
#property indicator_levelstyle STYLE_DOT                                //  1-  

#property indicator_level2 70                                           //2-  4-  
#property indicator_levelcolor Silver                                   //  2-  
#property indicator_levelstyle STYLE_DOT                                //  2-  

#property indicator_level3 30                                           //3-  4-  
#property indicator_levelcolor Silver                                   //  3-  
#property indicator_levelstyle STYLE_DOT                                //  3-  

#property indicator_level4 20                                           //4-  4-  
#property indicator_levelcolor Silver                                   //  4-  
#property indicator_levelstyle STYLE_DOT                                //  4-  

#property indicator_minimum 0                                           //    
#property indicator_maximum 100                                         //    
//+-------------------------------------------------------------------------------------- 3 --
double Buf_rsi[];                                                       //     RSI+
double Buf_ma[];                                                        //        RSI+
double Buf_up_line[];                                                   //       RSI+
double Buf_down_line[];                                                 //       RSI+
double Buf_std_dev[5509];                                               //         

extern int _RSI=14;                                               // :  RSI+
extern int _=PRICE_CLOSE;                                     // : ,  -  RSI+
extern int =0;                                                     // :     RSI+
extern double =2.0;                                                // :         RSI+
extern int =21;                                                       // :         RSI+
//+-------------------------------------  INIT ------------------------------------ 4 --
int init()                                                              // init
  {                                                                     // init
   switch(Period())                                                     //     
       {                                                                // switch
        case     1:string text="";int number=Period();    break;
        case     5:       text="";     number=Period();    break;
        case    15:       text="";     number=Period();    break;
        case    30:       text="";       number=Period();    break;
        case    60:       text="";       number=Period()/60; break;  // switch
        case   240:       text="";      number=Period()/240;break;        
        case  1440:       text="";      number=Period()/1440;break;
        case 10080:       text="";    number=Period()/10080;break;
        case 43200:       text="";     number=Period()/43200;break;
       }                                                                // switch
//+-------------------------------------------------------------------------------------- 5 --
   SetIndexBuffer(0,Buf_rsi);                                           //    RSI+    0
   SetIndexEmptyValue(0,0.0);                                           //      0
   IndicatorShortName("RSI+["+"("+_RSI+")"+", "+number+" "+text+"]");//    RSI+
   SetIndexLabel(0," RSI+("+number+" "+text+")");                  //    RSI+      DataWindow    
   SetIndexBuffer(1,Buf_ma);                                            //    MA  RSI+    1
   SetIndexLabel(1," (MA  RSI+), "+number+" "+text);               //    MA  RSI+      DataWindow    
   SetIndexDrawBegin(1,+_RSI+);                            //   +_RSI+   (..,   1-    RSI+,  +_RSI+ )
   SetIndexStyle(1,DRAW_LINE,2,0,Orange);                               //     MA  RSI+   0
   SetIndexEmptyValue(1,0.0);                                           //      0
   SetIndexBuffer(2,Buf_up_line);                                       //      RSI+    2
   SetIndexLabel(2,"  RSI+, "+number+" "+text);                    //      RSI+      DataWindow    
   SetIndexDrawBegin(2,+_RSI+);                            //   +_RSI+   (..,   1-    RSI+,  +_RSI+ )
   SetIndexEmptyValue(2,0.0);                                           //      0
   SetIndexBuffer(3,Buf_down_line);                                     //      RSI+    2
   SetIndexLabel(3,"  RSI+, "+number+" "+text);                    //      RSI+      DataWindow    
   SetIndexDrawBegin(3,+_RSI+);                            //   +_RSI+   (..,   1-    RSI+,  +_RSI+ )
   SetIndexEmptyValue(3,0.0);                                           //      0
   SetLevelValue(0,80);                                                 //    0=80
   SetLevelValue(1,70);                                                 //    1=70
   SetLevelValue(2,30);                                                 //    2=30
   SetLevelValue(3,20);                                                 //    3=20
//+-------------------------------------------------------------------------------------- 6 --
   return(0);                                                           //  init
  }                                                                     // init
//+-------------------------------------  INIT ------------------------------------------
//+------------------------------------  START ------------------------------------ 7 --
int start()                                                             // start
  {                                                                     // start
   string object_name=" "+TimeToStr(TimeLocal(),TIME_DATE|TIME_SECONDS);//   (-      )
   switch(Period())                                                     //     
       {                                                                // switch
        case     1:string text="";int number=Period();    break;
        case     5:       text="";     number=Period();    break;
        case    15:       text="";     number=Period();    break;
        case    30:       text="";       number=Period();    break;
        case    60:       text="";       number=Period()/60; break;  // switch
        case   240:       text="";      number=Period()/240;break;        
        case  1440:       text="";      number=Period()/1440;break;
        case 10080:       text="";    number=Period()/10080;break;
        case 43200:       text="";     number=Period()/43200;break;
       }                                                                // switch
   ObjectsDeleteAll(WindowFind("RSI+["+"("+_RSI+")"+", "+number+" "+text+"]"),OBJ_LABEL);//    . (   )
//+-------------------------------------------------------------------------------------- 8 --
   if(Bars<=_RSI) return(0);                                      //    ,   RSI+,  
//+-------------------------------------------------------------------------------------- 9 --
   int counted_bars=IndicatorCounted();                                 //  
   int i;                                                               // : 

   int limit=Bars-counted_bars;                                         //     Buf_ma (..      )
   if(counted_bars<0)limit--;                                           //   counted_bars  0,    1   limit
//+--------------------------------    ---------------------------- 10 --
   for(i=0;i<=limit;i++)Buf_rsi[i]=iRSI(NULL,0,_RSI,_,i);//  RSI+  i-       
   for(i=0;i<=limit;i++)                                                //      RSI+     
       {                                                                // for
        Buf_std_dev[i]=iStdDevOnArray(Buf_rsi,Bars,,,MODE_SMA,i);//     RSI+
        Buf_ma[i]=iMAOnArray(Buf_rsi,Bars,,,MODE_SMA,i);         //  MA  RSI+  i- 
        Buf_up_line[i]=Buf_ma[i]+*Buf_std_dev[i];                  //    RSI+
        Buf_down_line[i]=Buf_ma[i]-*Buf_std_dev[i];                //    RSI+
       }                                                                // for
   for(i=0;i<=Bars;i++)                                                 //      
      {                                                                 // for
       int sum;                                                         // :  , -    
       if(Buf_rsi[i]>Buf_down_line[i]&&Buf_rsi[i]<Buf_up_line[i])sum++; //  RSI+ >    RSI+ < ,   sum   1 (..)
      }                                                                 // for
//+------------------------------------------------------------------------------------- 11 --
   double number_2=ArraySize(Buf_rsi);                                  //  number_1   ArraySize(Buf_rsi)
   double number_3=sum/number_2*100;                               //    
   ObjectCreate(object_name,OBJ_LABEL,WindowFind("RSI+["+"("+_RSI+")"+", "+number+" "+text+"]"),0,0);//        RSI
   ObjectSet(object_name,OBJPROP_XDISTANCE,890);                        //  X-     " "
   ObjectSet(object_name,OBJPROP_YDISTANCE,4);                          //  Y-     " "
   ObjectSetText(object_name,DoubleToStr(number_3,2)+"%",10);           //    " "
   ObjectSet(object_name,OBJPROP_FONTSIZE,10);                          //      " "
   if(number_3<85)ObjectSet(object_name,OBJPROP_COLOR,Red);             //   85%,       
   if(number_3>=85)ObjectSet(object_name,OBJPROP_COLOR,DarkBlue);       //  85%  ,   
   WindowRedraw();                                                      //    
   Comment("\n Bars  : ",Bars,
           "\n 0  : ",Buf_rsi[0]);
//+------------------------------------------------------------------------------------- 12 --
   return(0);                                                           //  start
  }                                                                     // start
//+-------------------------------------  START ----------------------------------- 13 --

